



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【转】Python之面向对象与类</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【转】Python之面向对象与类</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-29 12:02:09 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><a href="https://www.cnblogs.com/yyds/p/7591804.html" rel="external nofollow noreferrer">【转】Python之面向对象与类</a></p>
<h2>本节内容</h2>
<hr />
<ol><li>面向对象的概念</li>
<li>类的封装</li>
<li>类的继承</li>
<li>类的多态</li>
<li>静态方法、类方法 和 属性方法</li>
<li>类的特殊成员方法</li>
<li>继承层级关系中子类的实例对象对属性的查找顺序问题</li></ol>
<h2>一、面向对象的概念</h2>
<hr />
<h3>1. "面向对象（OOP）"是什么？</h3>
<p>简单点说，&ldquo;面向对象&rdquo;是一种编程范式，而编程范式是按照不同的编程特点总结出来的编程方式。俗话说，条条大路通罗马，也就说我们使用不同的方法都可以达到最终的目的，但是有些办法比较快速、安全且效果好，有些方法则效率低下且效果不尽人意。同样，编程也是为了解决问题，而解决问题可以有多种不同的视角和思路，前人把其中一些普遍适用且行之有效的编程模式归结为&ldquo;范式&rdquo;。常见的编程范式有：</p>
<ul><li>面向过程编程：OPP（Procedure Oriented Programing）</li>
<li>面向对象编程：OOP（Object Oriented Programing）</li>
<li>函数式编程：(Functional Programing)</li></ul>
<h4>面向过程编程的步骤：</h4>
<p>1）分析出解决问题所需要的步骤；</p>
<p>2）用函数把这些步骤一次实现；</p>
<p>3）一个一个地调用这些函数来解决问题；</p>
<h4>面向对象编程的步骤：</h4>
<p>1）把构成问题的事务分解、抽象成各个对象；</p>
<p>2）结合这些对象的共有属性，抽象出类；</p>
<p>3）类层次化结构设计--继承 和 合成；</p>
<p>4）用类和实例进行设计和实现来解决问题。</p>
<p>关于面向对象编程 与 面向过程编程的区别与优缺点可以参考<a href="http://www.cnblogs.com/strivers/p/6681876.html" rel="external nofollow noreferrer">这篇文章</a></p>
<h3>2. 面向对象编程的特点</h3>
<p>面向对象编程达到了软件工程的3个目标：重用性、灵活性、扩展性，而这些目标是通过以下几个主要特点实现的：</p>
<ul><li><strong><em>封装：</em></strong> 可以隐藏实现细节，使代码模块化</li>
<li><strong><em>继承：</em></strong> 可以通过扩展已存在的类来实现代码重用，避免重复编写相同的代码</li>
<li><strong><em>多态：</em></strong> 封装和继承的目的都是为了实现 代码重用， 而多态是为了实现 接口重用，使得类在继承和派生的时候能够保证任何一个类的实例都能正确调用约定好的属性和方法。简单来说，就是为了约定相同的属性和方法名称。</li></ul>
<blockquote><p>需要说明的是，Python不像Java中又专门的&ldquo;接口&rdquo;定义，Python中的接口与类没有什么区别，但是我们可以通过在一个用于当做接口的类中所定义的方法体中 <code>raise NotImplementedError</code>异常，来强制子类必须重新实现该方法。</p></blockquote>
<h3>3. 面向对象编程的使用场景</h3>
<p>我们知道，Python既可以面向过程编程，也可以面向对象编程。那么什么场景下应该使用面向对象编程呢？如果我们仅仅是写一个简单的脚本来跑一些简单的任务，我们直接用面向过程编程就好了，简单，快速。当我们需要实现一个复杂的系统时，或者以下场景下，就需要使用面向对象编程：</p>
<ul><li><strong><em>场景1：</em></strong> 当多个函数需要传入多个共同的参数时，可以将这些函数封装到一个类中，并将这些参数提取为这个类的属性；</li>
<li><strong><em>场景2：</em></strong> 当需要根据一个模板来创建某些东西时，可以通过类来完成。</li></ul>
<h2>二、类的封装</h2>
<hr />
<p>封装是面向对象的主要特征之一，是对象和类概念的主要特性。简单的说，一个类就是一个封装了数据以及操作这些数据的方法的逻辑实体，它向外暴露部分数据和方法，屏蔽具体的实现细节。除此之外，在一个对象内部，某些数据或方法可以是私有的，这些私有的数据或方法是不允许外界访问的。通过这种方式，对象对内部数据提供了不同级别的保护以防止程序中无关的部分意外的改变或错误使用了对象的私有部分，比如java中修饰类变量和方法的相关关键字有：private、protected, public等。下面我们通过类的定义和实例化的实例来说明一下Python中的是如何实现对这些不同等级数据的保护的。</p>
<h3>1. 类的定义</h3>
<p>类的定义是对显示事务的抽象过程和能力，类是一个对象/实例的模板，也是一个特殊的对象/实例（因为Pythobn中一切皆对象，所以类本身也是一个对象）</p>
<p>现在我们来定义个Person类，它有以下3个属性：</p>
<ul><li>nationality：国籍</li>
<li>name：姓名</li>
<li>id：身份证号码</li></ul>
<p>假设现在我们有以下几个前提：</p>
<ul><li>所有人的国籍基本都是相同的，且允许直接通过类或实例来访问，允许随意修改</li>
<li>大部分人的姓名是不同的，且允许直接通过类的实例来访问和随意修改</li>
<li>所有人的身份证号码都是不一样的，且不允许直接通过类或实例来访问或随意修改</li></ul>
<pre class="prettyprint linenums"><code>import uuid

class Person(object):<br />
    nationality = 'China'

    def __init__(self, name):<br />
        self.name = name<br />
        self.__id = str(uuid.uuid1())

    def hello(self):<br />
        print('Hi, i am %s, from %s， my id is %s' % (self.name, self.nationality, self.__id))

    def get_and_print_id(self):<br />
        print(self.__id)<br />
        return self.__id<br />
</code></pre>
<h3>2. 类的实例化</h3>
<p>类实例化的方式：<code>类名([参数...])</code>，参数是__init__方法中除了第一个self参数之外的其他参数，上面定义的这个Person类中，实例化时需要传递的参数只有一个name。比如我们来实例化3个Person对象，他们的name分别是 tom 和 jerry：</p>
<pre class="prettyprint linenums"><code>tom = Person('tom')<br />
jerry = Person('jerry')<br />
jack = Person('jack')</code></pre>
<h3>3. 不同保护等级的属性说明</h3>
<h4>公有属性/类属性</h4>
<p><strong><em>直接定义在class下的属性就是公有属性/类属性</em></strong>，比如上面那个Person类中的nationality属性。&ldquo;公有&rdquo;的意思是这个属性是这个类的所有实例对象共同所有的，因此默认情况下这个属性值值保留一份，而不会为该类的每个实例都保存一份。</p>
<pre class="prettyprint linenums"><code>print(Person.nationality, tom.nationality, jerry.nationality, jack.nationality)

tom.nationality = 'USA'<br />
print(Person.nationality, tom.nationality, jerry.nationality, jack.nationality)

Person.nationality = 'India'<br />
print(Person.nationality, tom.nationality, jerry.nationality, jack.nationality)</code></pre>
<p>输出结果如下：</p>
<pre class="prettyprint linenums"><code>China China China China<br />
China USA China China<br />
India USA India India</code></pre>
<p>结论：</p>
<pre class="prettyprint linenums"><code>- 公有属性/静态属性 可以直接通过类直接访问，也可以直接通过实例进行访问；<br />
- 通过类的某个实例对公有属性进行修改，实际上对为该实例添加了一个与类的公有属性名称相同的成员属性，对真正的公有属性是没有影响的，因此它不会影响其他实例获取的该公有属性的值；<br />
- 通过类对公有属性进行修改，必然是会改变公有属性原有的值，他对该类所有的实例是都有影响的。</code></pre>
<h4>成员属性/实例属性</h4>
<p>成员属性，又称成员变量 或 实例属性，也就是说这些属性是 该类的每个实例对象单独持有的属性。成员属性需要在类的__init__方法中进行声明，比如上面的Person类中定义的name属性就是一个成员属性。</p>
<pre class="prettyprint linenums"><code>print(tom.name, jerry.name, jack.name)

jerry.name = 'jerry01'<br />
print(tom.name, jerry.name, jack.name)</code></pre>
<p>输出结果：</p>
<pre class="prettyprint linenums"><code>tom jerry jack<br />
tom jerry01 jack</code></pre>
<p>来看看能不能直接通过类访问成员属性</p>
<pre class="prettyprint linenums"><code>print(Person.name)</code></pre>
<p>输出结果：</p>
<pre class="prettyprint linenums"><code>Traceback (most recent call last):<br />
  ...<br />
AttributeError: type object 'Person' has no attribute 'name'</code></pre>
<p>结论：</p>
<pre class="prettyprint linenums"><code>- 成员属性可以直接通过实例对象来访问和更改；<br />
- 成员属性是每个实例对象独有的，某个实例对象的成员属性被更改不会影响其他实例对象的相同属性的值；<br />
- 成员属性的值不能通过类来访问和修改；</code></pre>
<h4>私有属性</h4>
<p>私有属性和成员属性一样，是在__init__方法中进行声明，但是属性名需要以双下划线__开头，比如上面定义的Person中的__id属性。私有属性是一种特殊的成员属性，它只允许在实例对象的内部（成员方法或私有方法中）访问，而不允许在实例对象的外部通过实例对象或类来直接访问，也不能被子类继承。</p>
<p>通过实例对象访问私有属性：</p>
<pre class="prettyprint linenums"><code>print(tom.__id)</code></pre>
<p>输出结果</p>
<pre class="prettyprint linenums"><code>Traceback (most recent call last):<br />
    ...<br />
AttributeError: 'Person' object has no attribute '__id'</code></pre>
<p>通过类访问私有属性：</p>
<pre class="prettyprint linenums"><code>print(Person.__id)</code></pre>
<p>输出结果：</p>
<pre class="prettyprint linenums"><code>Traceback (most recent call last):<br />
  ...<br />
AttributeError: type object 'Person' has no attribute '__id'</code></pre>
<p>通过类的成员方法访问私有属性：</p>
<pre class="prettyprint linenums"><code>tom.hello()<br />
jerry.hello()<br />
jack.hello()</code></pre>
<p>输出结果：</p>
<pre class="prettyprint linenums"><code>Hi, i am tom, from China， my id is b6ac08c6-9dae-11e7-993f-208984d7aa83<br />
Hi, i am jerry, from China， my id is b6ac08c7-9dae-11e7-b508-208984d7aa83<br />
Hi, i am jack, from China， my id is b6ac08c8-9dae-11e7-9ace-208984d7aa83</code></pre>
<p>结论：</p>
<pre class="prettyprint linenums"><code>- 私有变量不能通过类直接访问；<br />
- 私有变量也不能通过实例对象直接访问；<br />
- 私有变量可以通过成员方法进行访问。</code></pre>
<p><strong><em>那么要访问私有变量怎么办呢？</em></strong> 有两种办法：</p>
<p>办法1：通过一个专门的成员方法返回该私有变量的值，比如上面定义的get_id()方法，搞过java的同学很自然就会想到java类中的set和get方法。</p>
<pre class="prettyprint linenums"><code>tom_id = tom.get_id()<br />
jerry_id = jerry.get_id()<br />
jack_id = jack.get_id()

print(tom_id, jerry_id, jack_id)</code></pre>
<p>输出结果：</p>
<pre class="prettyprint linenums"><code>46bc6b5c-9dd6-11e7-8306-208984d7aa83 46cbfe68-9dd6-11e7-b5d1-208984d7aa83 46cbfe69-9dd6-11e7-9b5c-208984d7aa83</code></pre>
<p>办法2：通过 <code>实例对象._类名__私有变量名</code> 的方式来访问</p>
<pre class="prettyprint linenums"><code>print(tom._Person__id, jerry._Person__id, jack._Person__id)</code></pre>
<p>输出结果：</p>
<pre class="prettyprint linenums"><code>e1f4ee86-9dd6-11e7-a186-208984d7aa83 e1f5b1f8-9dd6-11e7-b1c3-208984d7aa83 e1f5b1f9-9dd6-11e7-b74a-208984d7aa83</code></pre>
<h4>总结</h4>
<ul><li>公有属性、成员属性 和 私有属性 的受保护等级是依次递增的；</li>
<li>私有属性 和 成员属性 是存放在已实例化的对象中的，每个对象都会保存一份；</li>
<li>公有属性是保存在类中的，只保存一份；</li>
<li>哪些属性应该是公有属性的，哪些属性应该是私有属性 需要根据具体业务需求来确定。</li></ul>
<h2>三、类的继承</h2>
<hr />
<h3>1. 继承的相关概念</h3>
<p><strong><em>继成</em></strong> 和 <strong><em>组合</em></strong> 是类的两个最主要的关系，而 <strong><em>继承</em></strong> 关系的类之间是有层级的。被继承的类被称为 <strong><em>父类、基类 或 超类</em></strong> ；继承的类被称为 <strong><em>子类 或 派生类</em></strong>。</p>
<h3>2. 继承的作用</h3>
<p>继承 是一个从一般到特殊的过程， 子类可以继承现有类的所有功能，而不需要重新实现代码。简单来说就是 <strong><em>继承提高了代码重用性和扩展性</em></strong>。</p>
<h3>3. 继承的分类</h3>
<p>Python中类的继承按照父类中的方法是否已实现可分为两种：</p>
<ul><li><strong><em>实现继承</em></strong> ：指直接继承父类的属性和已定义并实现的的方法；</li>
<li><strong><em>接口继承</em></strong> ：仅继承父类类的属性和方法名称，子类必须自行实现方法的具体功能代码。</li></ul>
<p>如果是根据要继承的父类的个数来分，有可以分为：</p>
<ul><li><strong><em>单继承：</em></strong> 只继承1个父类</li>
<li><strong><em>多继承：</em></strong> 继承多个父类<br />
通常，我们都是用 单继承 ，很少用到 多继承。</li></ul>
<h3>4. 类继承实例</h3>
<h4>类的继承关系</h4>
<h5>父类/基类/超类--Person</h5>
<pre class="prettyprint linenums"><code>class Person(object):<br />
    def __init__(self, name, age):<br />
        self.name = name<br />
        self.age = age

    def walk(self):<br />
        print('%s is walking...' % self.name)

    def talk(self):<br />
        print('%s is talking...' % self.name )</code></pre>
<h5>子类--Teacher</h5>
<pre class="prettyprint linenums"><code>class Teacher(Person):<br />
    def __init__(self, name, age, level, salary):<br />
        super(Teacher, self).__init__(name, age)<br />
        self.level = level<br />
        self.salary = salary

    def teach(self):<br />
        print('%s is teaching...' % self.name)</code></pre>
<h5>子类--Class</h5>
<pre class="prettyprint linenums"><code>class Student(Person):<br />
    def __init__(self, name, age, class_):<br />
        Person.__init__(self, name, age)<br />
        self.class_ = class_

    def study(self):<br />
        print('%s is studying...' % self.name)</code></pre>
<h4>子类实例化</h4>
<pre class="prettyprint linenums"><code>t1 = Teacher('张老师', 33, '高级教师', 20000)<br />
s1 = Student('小明', 13, '初一3班')

t1.talk()<br />
t1.walk()<br />
t1.teach()

s1.talk()<br />
s1.walk()<br />
s1.study()</code></pre>
<p>输出结果：</p>
<pre class="prettyprint linenums"><code>张老师 is talking...<br />
张老师 is walking...<br />
张老师 is teaching...<br />
小明 is talking...<br />
小明 is walking...<br />
小明 is studying...</code></pre>
<h4>继承说明</h4>
<ul><li>Teacher类 和 Student类 都继承 Person类，因此Teacher和Student是Person的子类/派生类，而Person是Teacher和Student的父类/基类/超类；</li>
<li>Teacher和Student对Person的继承属于实现继承，且是单继承；</li>
<li>Teacher类继承了Person的name和age属性，及talk()和walk()方法，并扩展了自己的level和salary属性，及teach()方法；</li>
<li>Student类继承了Person的name和age属性，及talk()和walk()方法，并扩展了自己的class属性，及study()方法；</li>
<li>Teacher和Student对Person类属性和方法继承体现了 &ldquo;代码的重用性&rdquo;， 而Teacher和Student扩展的属性和方法体现了 &ldquo;灵活的扩展性&rdquo;；</li>
<li>子类需要在自己的__init__方法中的第一行位置调用父类的构造方法，上面给出了两种方法：
<ul><li>super(子类名, self).__init__(父类构造参数)，如super.(Teacher, self).__init__(name, age)</li>
<li>父类名.__init__(self, 父类构造参数)，如Person.__init__(self, name, age)，这是老式的用法。</li></ul></li>
<li>子类 Teacher 和 Student 也可以在自己的类定义中 重新定义 父类中的talk()和walk()方法，改变其实现代码，这叫做<strong><em>方法重写</em></strong>。</li></ul>
<blockquote><p>关于多继承，以及多继承时属性查找顺序（广度优先、深度优先）的问题会在下面进行单独说明。</p></blockquote>
<h2>四、类的多态</h2>
<hr />
<p>多态是指，相同的成员方法名称，但是成员方法的行为（代码实现）却各不相同。这里所说的多态是通过 继承接口的方式实现的。Java中有interface，但是Python中没有。Python中可以通过在一个成员方法体中抛出一个<code>NotImplementedError</code>异常来强制继承该接口的子类在调用该方法前必须先实现该方法的功能代码。</p>
<h4>接口--Animal</h4>
<pre class="prettyprint linenums"><code>class Animal(object):<br />
    def __init__(self, name):<br />
        self.name = name

    def walk(self):<br />
        raise NotImplemented('Subclass must implement the abstract method by self')

    def talk(self):<br />
        raise NotImplemented('Subclass must implement the abstract method by self')<br />
</code></pre>
<h4>子类--Dog</h4>
<pre class="prettyprint linenums"><code>class Dog(Animal):<br />
    pass</code></pre>
<p>执行代码：</p>
<pre class="prettyprint linenums"><code>dog = Dog('大黄')<br />
dog.talk()</code></pre>
<p>输出结果：</p>
<pre class="prettyprint linenums"><code>Traceback (most recent call last):<br />
  ...<br />
    raise NotImplemented('Subclass must implement the abstract method by self')<br />
TypeError: 'NotImplementedType' object is not callable</code></pre>
<p>可见，此时子类必须自己先实现talk方法才能调用。</p>
<h4>实现了接口方法的子类--Dog 和 Duck</h4>
<pre class="prettyprint linenums"><code>class Dog(Animal):<br />
    def talk(self):<br />
        print('%s is talking：旺旺...' % self.name)

    def walk(self):<br />
        print('%s 是一条小狗，用4条腿走路' % self.name)

class Duck(Animal):<br />
    def talk(self):<br />
        print('%s is talking: 嘎嘎...' % self.name)

    def walk(self):<br />
        print('%s 是一只鸭子，用两条腿走路' % self.name)</code></pre>
<p>执行代码：</p>
<pre class="prettyprint linenums"><code>dog = Dog('大黄')<br />
dog.talk()<br />
dog.walk()

duck = Duck('小白')<br />
duck.talk()<br />
duck.walk()</code></pre>
<p>输出结果：</p>
<pre class="prettyprint linenums"><code>大黄 is talking：旺旺...<br />
大黄 是一条小狗，用4条腿走路<br />
小白 is talking: 嘎嘎...<br />
小白 是一只鸭子，用两条腿走路</code></pre>
<p>由此可知：</p>
<ul><li>接口的所有子类拥有接口中定义的所有同名的方法；</li>
<li>接口的所有子类在调用接口中定义的方法时，必须先自己实现方法代码；</li>
<li>接口的各个子类在实现接口中同一个方法时，具体的代码实现各不相同，这就是多态。</li></ul>
<h2>五、属性方法、类方法、静态方法</h2>
<hr />
<p>上面提到过，类中封装的是数据和操作数据的方法。数据就是属性，且上面已经介绍过了属性分为：<br />
公有属性/类变量、成员属性/实例变量 和 私有属性。现在我们来说说类中的方法，类中的方法分为以下几种：</p>
<ul><li><p><strong><em>成员方法：</em></strong> 上面定义的都是成员方法，通常情况下，它们与成员属性相似，是通过类的实例对象去访问；成员方法的第一个参数必须是当前实例对象，通常写为self；实际上，我们也可以通过类名来调用成员方法，只是此时我们需要手动的传递一个该类的实例对象给成员方法的self参数，这样用明显不是一种优雅的方法，因此基本不会这样使用。</p></li>
<li><p><strong><em>私有方法：</em></strong> 以双下划线开头的成员方法就是私有方法，与私有属性类似，只能在实例对象内部访问，且不能被子类继承；私有方法的第一个参数也必须是当前实例对象本身，通常写为self；</p></li>
<li><p><strong><em>类方法：</em></strong> 以@classmethod来装饰的成员方法就叫做类方法，它要求第一次参数必须是当前类。与公有属性/静态属性 相似，除了可通过实例对象进行访问，还可以直接通过类名去访问，且第一个参数表示的是当前类，通常写为cls；另外需要说明的是，类方法只能访问公有属性，不能访问成员属性，因此第一个参数传递的是代表当前类的cls，而不是表示实例对象的self。</p></li>
<li><p><strong><em>静态方法：</em></strong> 以@staticmethod来装饰的成员方法就叫做静态方法，静态方法通常都是通过类名去访问，且严格意义上来讲，静态方法已经与这个类没有任何关联了，因为静态方法不要求必须传递实例对象或类参数，这种情况下它不能访问类中的任何属性和方法。</p></li>
<li><p><strong><em>属性方法：</em></strong> 这个比较有意思，是指可以像访问成员属性那样去访问这个方法；它的第一个参数也必须是当前实例对象，且该方法必须要有返回值。</p></li></ul>
<p>我们先来定义这样一个类：</p>
<pre class="prettyprint linenums"><code>import uuid

class Person(object):<br />
    nationality = 'China'

    def __init__(self, name, age):<br />
        self.name = name<br />
        self.age = age<br />
        self.__id = str(uuid.uuid1())

    # 成员方法/实例方法<br />
    def sayHello(self):<br />
        print('Hello, i am %s from %s, i am %d years old.' % (self.name, self.nationality, self.age))

    # 私有方法<br />
    def __func0(self):<br />
        print('private method: func0')<br />
        print(self.name, self.age, self.__id, self.nationality)

    # 类方法<br />
    @classmethod<br />
    def func1(cls):<br />
        print(cls.nationality)

    # 静态方法<br />
    @staticmethod<br />
    def func2(a, b):<br />
        print(a + b)

    #　属性方法<br />
    @property<br />
    def func3(self):<br />
        return '%s: %d' % (self.name, self.age)</code></pre>
<p>执行代码：</p>
<pre class="prettyprint linenums"><code>p = Person('Tom', 18)

p.sayHello()<br />
Person.sayHello(p)

Person.func1()<br />
p.func1()

Person.func2(3, 4)<br />
p.func2(3, 4)

print(p.func3)</code></pre>
<p>输出结果：</p>
<pre class="prettyprint linenums"><code>Hello, i am Tom from China, i am 18 years old.<br />
Hello, i am Tom from China, i am 18 years old.

China<br />
China

7<br />
7

Tom: 18</code></pre>
<blockquote><p><strong><em>总结：</em></strong></p></blockquote>
<blockquote><ul><li>成员方法也可以通过类名去访问，但是有点多此一举的感觉；</li>
<li>类方法和静态方法也可以通过实例对象去访问，但是通常情况下都是通过类名直接访问的；</li>
<li>最重要的一条总结：类的各种方法，能访问哪些属性实际上是跟方法的参数有关的：
<ul><li>比如成员方法要求第一个参数必须是一个该类的实例对象，那么实例对象能访问的属性，成员方法都能访问，而且还能访问私有属性；</li>
<li>再比如，类方法要求第一个参数必须是当前类，因此它只能访问到类属性/公有属性，而访问不到成员属性 和 私有属性；</li>
<li>再比如，静态方法对参数没有要求，也就意味着我们可以任意给静态方法定义参数；假如我们给静态方法定义了表示当前类的参数，那么就可以访问类属性/公有属性；假如我们给静态方法定义了表示当前类的实例对象的参数，那么就可以访问成员属性；假如我们没有给静态方法定义这两个参数，那么就不能访问该类或实例对象的任何属性。</li></ul></li></ul></blockquote>
<h2>六、类的特殊成员属性及特殊成员方法</h2>
<hr />
<p>我们上面提到过：名称以双下划线__开头的属性是私有属性，名称以双下划线__开头的方法是私有方法。这里我们要来说明的是，Python的类中有一些内置的、特殊的属性和方法，它们的名称是以双下划线__开头，同时又以双下划线__结尾。这些属性和方法不再是私有属性和私有方法，它们是可以在类的外部通过实例对象去直接访问的，且它们都有着各自特殊的意义，我们可以通过这些特殊属性和特殊方法来获取一些重要的信息，或执行一些有用的操作。</p>
<h3>1. 类的特殊成员属性</h3>
<table>
<thead>
<tr>
<th>属性名称</th>
<th>说明</th>
</tr>
</thead>
<tbody>
<tr>
<td>__doc__</td>
<td>类的描述信息</td>
</tr>
<tr>
<td>__module__</td>
<td>表示当前操作的对象对应的类的定义所在的模块名</td>
</tr>
<tr>
<td>__class__</td>
<td>表示当前操作的对象对应的类名</td>
</tr>
<tr>
<td>__dict__</td>
<td>一个字典，保存类的所有的成员（包括属性和方法）或实例对象中的所有成员属性</td>
</tr>
</tbody>
</table>
<p>现在来看一个实例：</p>
<p>在dog.py模块定义一个Dog类</p>
<pre class="prettyprint linenums"><code>class Dog(object):<br />
    """这是一个Dog类"""<br />
    # print('Hello, This is a dog.')<br />
    color = '白色'

    def __init__(self, name):<br />
        self.name = name<br />
        self.__id = 1234

    def func1(self):<br />
        pass

    def __func1(self):<br />
        pass

    @classmethod<br />
    def func2(cls):<br />
        pass

    @staticmethod<br />
    def func3():<br />
        pass<br />
</code></pre>
<p>在test.py模块执行下面的代码</p>
<pre class="prettyprint linenums"><code>from dog import Dog

dog1 = Dog('泰迪')<br />
print(dog1.__doc__)<br />
print(dog1.__module__)<br />
print(dog1.__class__)<br />
print(dog1.__dict__)<br />
print(Dog.__dict__)</code></pre>
<p>输出结果</p>
<pre class="prettyprint linenums"><code>这是一个Dog类<br />
dog<br />
&lt;class 'dog.Dog'&gt;<br />
{'name': '泰迪', '_Dog__id': 1234}<br />
{'__dict__': &lt;attribute '__dict__' of 'Dog' objects&gt;, '__module__': 'dog', 'func2': &lt;classmethod object at 0x000001DF0C658F98&gt;, 'color': '白色', 'func3': &lt;staticmethod object at 0x000001DF0C658FD0&gt;, '_Dog__func1': &lt;function Dog.__func1 at 0x000001DF0C63E400&gt;, '__weakref__': &lt;attribute '__weakref__' of 'Dog' objects&gt;, '__doc__': '这是一个Dog类', '__init__': &lt;function Dog.__init__ at 0x000001DF0C63E2F0&gt;, 'func1': &lt;function Dog.func1 at 0x000001DF0C63E378&gt;}</code></pre>
<p>总结：</p>
<ul><li>实例对象.__dict__ 和 类.__dict__ 的值是不同的：实例对象.__dict__的值中只包含成员属性和私有属性，类.__dict__的值中包含公有属性/类属性和所有类型的方法；</li>
<li>__module__和__class__的值可用于反射来实例化一个类的对象，下面会介绍。</li></ul>
<h3>2. 类的特殊成员方法</h3>
<table>
<thead>
<tr>
<th>方法名称</th>
<th>说明</th>
</tr>
</thead>
<tbody>
<tr>
<td>__init__</td>
<td>类构造方法，通过类创建对象时会自动触发执行该方法</td>
</tr>
<tr>
<td>__del__</td>
<td>析构方法，当对象在内存中被什邡市，会自动触发执行该方法。比如实例对象的作用域退出时，或者执行 <code>del 实例对象</code>操作时。</td>
</tr>
<tr>
<td>__str__</td>
<td>如果一个类中定义了__str__方法，那么在打印对象时默认输出该方法的返回值，否则会打印出该实例对象的内存地址。</td>
</tr>
<tr>
<td>__xxxitem__</td>
<td>是指__getitem__、__setitem__、__delitem这3个方法，它们用于索引操作，比如对字典的操作，分别表示 获取、设置、删除某个条目。 数据。可以通过这些方法来定义一个类对字典进行封装，从而可以对字典中key的操作进行控制，尤其是删除操作。</td>
</tr>
<tr>
<td>__new__</td>
<td>该方法会在__init__方法之前被执行，该方法会创建被返回一个新的实例对象，然后传递给__init__。另外需要说明的是，这不是一个成员方法，而是一个静态方法。</td>
</tr>
<tr>
<td>__call__</td>
<td>源码中的注释是"Call self as a function." 意思是把自己（实例对象）作为一个函数去调用，而函数的调用方式是<code>函数名()</code>。也就是说，当我们执行<code>实例对象()</code>或者 <code>类名()()</code>这样的操作时会触发执行该方法。</td>
</tr>
</tbody>
</table>
<h4>示例1</h4>
<p>先来定义这样一个类：</p>
<pre class="prettyprint linenums"><code>class Person(object):<br />
    def __call__(self, *args, **kwargs):<br />
        print(self.name, '__call__')

    def __init__(self, name, age):<br />
        self.name = name<br />
        self.age = age<br />
        print(self.name, '__init__')

    def __del__(self):<br />
        print(self.name, '__del__')

    def __str__(self):<br />
        print(self.name, '__str__')<br />
        return '%s: %d'% (self.name, self.age)</code></pre>
<p>执行下面的代码：</p>
<pre class="prettyprint linenums"><code>print('--------实例化对象-----------')<br />
p = Person('Tom', 18)<br />
print('--------打印实例对象-----------')<br />
print(p)<br />
print('--------把实例对象作为方法进行调用-----------')<br />
p()  # 等价于 Person('Tom', 18)()<br />
print('--------程序运行结束-----------')</code></pre>
<p>输出结果：</p>
<pre class="prettyprint linenums"><code>--------实例化对象-----------<br />
Tom __init__<br />
--------打印实例对象-----------<br />
Tom __str__<br />
Tom: 18<br />
--------把实例对象作为方法进行调用-----------<br />
Tom __call__<br />
--------程序运行结束-----------<br />
Tom __del__</code></pre>
<blockquote><p>可以看到，所有代码都执行完后，进程退出时实例对象的__del__方法才被调用，这是因为对象要被销毁了。</p></blockquote>
<h4>示例2</h4>
<p>定义一个类似字典的类</p>
<pre class="prettyprint linenums"><code>class MyDict(object):<br />
    def __init__(self, init=None):<br />
        self.__dict = init if init is not None else {}

    def __setitem__(self, key, value):<br />
        print('__setitem__', key)<br />
        self.__dict[key] = value

    def __getitem__(self, item):<br />
        print('__getitem__', item)<br />
        return self.__dict.get(item, None)

    def __delitem__(self, key):<br />
        print('__delitem__', key)<br />
        if key is not None and key.startswith('wh'):<br />
            print('You can not delete this item ')<br />
            return None<br />
        return self.__dict.pop(key, None)</code></pre>
<p>执行下面的代码</p>
<pre class="prettyprint linenums"><code># 类实例化与get item<br />
my_dict = MyDict(init={'what': '打豆豆', 'who': '企鹅团', 'time': '吃饱睡好之后'})<br />
print(my_dict['who'], my_dict['time'], my_dict['what'])

# set item<br />
my_dict['num'] = '10次'<br />
print(my_dict['who'], my_dict['time'], my_dict['what'], my_dict['num'])

# del item<br />
del my_dict['num']<br />
print(my_dict['num'])

del my_dict['what']<br />
print(my_dict['what'])</code></pre>
<p>输出结果</p>
<pre class="prettyprint linenums"><code>__getitem__ who<br />
__getitem__ time<br />
__getitem__ what<br />
企鹅团 吃饱睡好之后 打豆豆

__setitem__ num<br />
__getitem__ who<br />
__getitem__ time<br />
__getitem__ what<br />
__getitem__ num<br />
企鹅团 吃饱睡好之后 打豆豆 10次

__delitem__ num<br />
__getitem__ num<br />
None

__delitem__ what<br />
You can not delete this item<br />
__getitem__ what<br />
打豆豆</code></pre>
<blockquote><p>可见，如果一个类实现了__setitem__，__getitem<strong>、__delitem</strong> 这几个方法，就可以执行一些类似字典一样的操作，比如上面用到的：</p>
<ul><li><code>my_dict['KEY']</code> 会自动调用my_dict实例对象的__getitem__方法；</li>
<li><code>my_dict['KEY'] = VALUE</code> 会自动调用my_dict实例对象的__setitem__方法；</li>
<li><code>del my_dict['KEY']</code> 会自动调用my_dict实例独享的__delitem__方法；<br />
而我们定义这样一个类的目的在于，我们可以更好对字典操作进行控制，比如上面的例子中我们不允许删除key以'wh'开头的条目。</li></ul></blockquote>
<h2>七、继承层级关系中子类的实例对象对属性的查找顺序问题</h2>
<hr />
<p>有的同学说：&ldquo;这个还不简单吗？<strong><em>子类肯定是先找自己有没有这个属性或方法，有的话直接调用自己的，没有再去父类里面找。</em></strong>&rdquo; 没毛病，确实是这样的，但是我们真的理解这句话了吗？另外，如果是多继承且有多个类的层级关系，查找顺序又是怎样的呢？再来简单描述下这里要讨论的问题是什么，简单来说，就是要大家搞明白2个问题：</p>
<ul><li>1）子类的实例对象调用的某个属性或方法到底是父类的还是自己的；</li>
<li>2）如果是多继承（同时继承多个父类），调用的的到底是哪个父类的属性或方法，查找顺序是怎样的。</li></ul>
<p>如果大家把这2问题搞明白了，这里目的就达到了。下面我们分别以单继承和多继承两个实例来讲解我们这里要说明的问题。</p>
<h3>1. 单继承的情况</h3>
<p>A、B、C三个类的定义如下：</p>
<pre class="prettyprint linenums"><code>class A(object):<br />
    def __init__(self, name):<br />
        self.name = name

    def func1(self):<br />
        print('class A: func1')

    def func2(self):<br />
        print('class A: func2')

class B(A):<br />
    def __init__(self, name, age):<br />
        super(B, self).__init__(name)<br />
        self.age = age

    def func2(self):<br />
        print('class B: func2')

class C(A):<br />
    def func1(self):<br />
        print('class C: func1')

    def func3(self):<br />
        print('class C: func3')<br />
</code></pre>
<p>现在要执行这段代码：</p>
<pre class="prettyprint linenums"><code>objB = B('Tom', 18)<br />
objC = C('Jerry')

print(objB.name, objB.age)<br />
print(objC.name)<br />
objB.func1()<br />
objC.func1()</code></pre>
<blockquote><p>请先思考下面代码的输出结果，再去看下面的答案。</p></blockquote>
<p>输出结果：</p>
<pre class="prettyprint linenums"><code>Tom 18<br />
Jerry<br />
class A: func1<br />
class C: func1</code></pre>
<p>这是最简单的情况，也是最容易用开头那段话来解释清楚的情况，因此不做过多赘述。但这只是个引子，真正要讨论的是下面这种情况：</p>
<p>A与B两个类的定义如下：</p>
<pre class="prettyprint linenums"><code>class A(object):<br />
    def __init__(self, name):<br />
        self.name = name

    def func1(self):<br />
        print('class A: func1')<br />
        self.func2()

    def func2(self):<br />
        print('class A: func2')

class B(A):<br />
    def __init__(self, name, age):<br />
        super(B, self).__init__(name)<br />
        self.age = age

    def func2(self):<br />
        print('class B: func2')</code></pre>
<p>现在要执行下面的代码：</p>
<pre class="prettyprint linenums"><code>objB = B('Tom', 18)<br />
objB.func1()</code></pre>
<p>你心里有答案了吗？func1必然是执行的父类 A中的func1，因为子类B中没有这个方法。那么父类func1中调用的func2方法，到底是父类的还是子类的呢？解决了这个疑问，答案自然就出来了。</p>
<h5>分析1：</h5>
<p>class B 是class A的子类，因此它会继承class A的的方法func1和func2。但是，class B已经重写了func2，可以理解为class A中的func2方法已经被覆盖了，class B现在只能看到自己重写后的那个func2方法，所以func1中调用的应该是class B 重写后的func2方法。</p>
<h5>分析2：</h5>
<p>有的同学可能不太能理解，class A中的方法怎么能调用class B中的方法呢？下面我们来看下class B与class<br />
A的包含关系图：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1063221/201709/1063221-20170923185429009-1628983703.png" /></p>
<p>因为子类 class B继承了 class A的内容，因此绿框中的内容（class A）是属于蓝框（class B）中的一部分，他们应该看做一个整体。绿框中的func1是可以调用绿框外的func2的，因为他们都是objB中的成员方法。其实理解这些之后，现在我们来套用开始那句话：</p>
<ul><li><strong><em>func1方法的查找与调用：</em></strong> objB调用func1方法，发现class B本身（蓝框内的直接内容）并没有该方法，所以去父类class A（蓝框内的绿框）中去找，发现找到了，于是进行调用；</li>
<li><strong><em>func2方法的查找与调用：</em></strong> func1中调用了func2方法，这个时候还是先找子类class B本身（蓝框内的直接内容），发现找到了，于是直接调用子类自己的func2方法。</li></ul>
<p>因此上面这段代码的执行结果是：</p>
<pre class="prettyprint linenums"><code>class A: func1<br />
class B: func2</code></pre>
<h3>2. 多继承的情况</h3>
<h4>新式类 与 经典类</h4>
<p>Python 2.2引入了<strong><em>新式类</em></strong>，与它对应的是<strong><em>经典类</em></strong>，这里我们仅仅是解释下他们的概念，为讲解下面的内容做铺垫，不会深入讨论的它们的之间的区别。这里我们主要说明一下几个点就可以了：</p>
<ul><li>Python 2.x中，默认是经典类，只有显示继承了object的才是新式类；</li>
<li>Python 3.x中，默认就是新式类，经典类已经被废弃；</li>
<li>新式类的子类也是新式类</li></ul>
<h4>深度优先 与 广度优先</h4>
<p>深度优先 可以理解为 纵向优先，广度优先 可以理解为 水平方法优先。我们知道，类与类之间是有层级关系的，父类与子类是纵向的层级关系，同一个父类的多个直接子类是水平方向的同级关系。</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1063221/201709/1063221-20170925103347573-576612999.png" /></p>
<p>上图中 A是父类、B和C是继承A的子类，D是同时继承B和C的子类。此时D的一个实例对象去查找一个父类中的属性或方法的查找顺序就有两种可能，但是这两种查找顺序中第一个查找的父类必然都是B：</p>
<ul><li>B--&gt;A--&gt;C：这就是深度优先，因为优先查找的是与B上一层级的、纵向的A</li>
<li>B--&gt;C--&gt;A：这就是广度优先，因为优先查找的是与B同一层极的、水平方向的C</li></ul>
<h4>实例</h4>
<p>定义以下几个类：</p>
<pre class="prettyprint linenums"><code>class A(object):<br />
    def func1(self):<br />
        print('class A: func1')

    def func2(self):<br />
        print('class A: func2')

class B(A):<br />
    def func3(self):<br />
        print('class B: func3')

class C(A):<br />
    def func1(self):<br />
        print('class C: func1')

class D(B, C):<br />
    pass</code></pre>
<p>执行如下代码：</p>
<pre class="prettyprint linenums"><code>objD = D()<br />
objD.func1()</code></pre>
<p>Python 2.7 和 Python 3.5的输出结果都是一样的：</p>
<pre class="prettyprint linenums"><code>class C: func1</code></pre>
<p>我们更改下A的定义，不显示的指定其继承object：</p>
<pre class="prettyprint linenums"><code>class A():<br />
    def func1(self):<br />
        print('class A: func1')

    def func2(self):<br />
        print('class A: func2')

class B(A):<br />
    def func3(self):<br />
        print('class B: func3')

class C(A):<br />
    def func1(self):<br />
        print('class C: func1')

class D(B, C):<br />
    pass</code></pre>
<p>再来执行同样的代码：</p>
<pre class="prettyprint linenums"><code>objD = D()<br />
objD.func1()</code></pre>
<p>Python 2.7的输出结果：</p>
<pre class="prettyprint linenums"><code>class A: func1</code></pre>
<p>Python 3.5的输出结果：</p>
<pre class="prettyprint linenums"><code>class C: func1</code></pre>
<h4>结论</h4>
<p>前面我们已经说过了 在Python 3.x中无论是否显示指定继承object，所有的类都是新式类，那么我们根据上面的两个实例的输出结果可以得出这样的结论：<strong><em>在多继承的情况下，经典类查找父类属性或方法的顺序是深度优先，新式类查找父类属性的顺序是广度优先。</em></strong></p>
<blockquote><p>由于篇幅问题，还有几个与类相关的话题会单独再写一篇，比如类的实例化过程、反射以及异常类的介绍和使用等。</p>
<h4>问题交流群：666948590</h4></blockquote>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qyyyvgq.html">Python 的简单图形界面编程【草】</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q77wk1q.html">测试Oracle 11gr2 RAC 非归档模式下，offline drop数据文件后的数据库的停止与启动测试全过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql507e8.html">Eclipse 显示所有文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8exmdkq.html">select接收后台返回值的解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq404d08.html">hdu1879   继续畅通工程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1vxjoq.html">Cantor的数表 【找规律】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv10641q.html">JQgrid表格的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzdem08.html">javaWeb 基础知识</a>
		</li>
						<li><a href="https://www.batexi.com/a/8megrooq.html">Java NIO系列教程（一） Java NIO 概述</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j6gynq.html">&lpar;转&rpar;linux进程 linux线程 信息查看 ps top pstree</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvy70k8.html">如何比sketch和axure更方便地给原型做交互？</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kjx0wq.html">PostgreSQL代码分析，查询优化部分，canonicalize&lowbar;qual</a>
		</li>
						<li><a href="https://www.batexi.com/a/963yg4n9.html">centos7  端口转发</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pp6ke79.html">catalina&period;home和catalina&period;base这两个属性的作用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnl27mq.html">C&num;通过WMI读取MAC地址</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kl2owq.html">cookies封装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnok2jq.html">随手练&mdash;&mdash;洛谷-P1151（枚举与暴力搜索）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjnmevq.html">&lpar;14&rpar; go 结构体</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnd22z28.html">Go语言中的匿名函数和闭包的样子</a>
		</li>
						<li><a href="https://www.batexi.com/a/8odvrdxq.html">centos svnversion安装部署</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8e455yj9.html">python多重继承的钻石问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1vv2eq.html">social-auth-app-django集成第三方登录</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2ll3rq.html">字符设备驱动&lpar;六&rpar;按键poll机制</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2lp62q.html">mysql 遍历所有的库并根据表和sql语句备份</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rjpj49.html">ntp 时间同步</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rjpyn9.html">JAVA核心技术I---JAVA基础知识（知识回顾）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllnvrxq.html">ContentType组件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv5wgy8.html">理解self与this</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyy46jxq.html">Linux命令（十二）制作静态库和共享库</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2z3dx9.html">java内部类的作用</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
